# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List
from typing import Optional, Set
from typing_extensions import Self

class BillingMeterSummary(BaseModel):
    """
    BillingMeterSummary
    """ # noqa: E501
    aggregated_value: StrictInt = Field(description="Aggregated value of all the events within start_time and end_time. The aggregation strategy is defined on meter via default_aggregation.")
    document_count: StrictInt = Field(description="Count of events found within start_time and end_time.")
    end_datetime: datetime = Field(description="End datetime for this event summary")
    meter_id: StrictStr = Field(description="The if of billing meter associated with this event summary.")
    start_datetime: datetime = Field(description="Start datetime for this event summary")
    __properties: ClassVar[List[str]] = ["aggregated_value", "document_count", "end_datetime", "meter_id", "start_datetime"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BillingMeterSummary from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BillingMeterSummary from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "aggregated_value": obj.get("aggregated_value"),
            "document_count": obj.get("document_count"),
            "end_datetime": obj.get("end_datetime"),
            "meter_id": obj.get("meter_id"),
            "start_datetime": obj.get("start_datetime")
        })
        return _obj


