# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from getopenpay.models.calendar_interval_enum import CalendarIntervalEnum
from getopenpay.models.currency_enum import CurrencyEnum
from getopenpay.models.object_name import ObjectName
from typing import Optional, Set
from typing_extensions import Self

class CheckoutSessionLineItemExternal(BaseModel):
    """
    CheckoutSessionLineItemExternal
    """ # noqa: E501
    amount_subtotal_atom: StrictInt
    amount_total_atom: StrictInt
    billing_interval: Optional[CalendarIntervalEnum]
    billing_interval_count: Optional[StrictInt]
    checkout_session_id: Optional[StrictStr]
    created_at: datetime = Field(description="DateTime at which the object was created, in 'ISO 8601' format.")
    currency: CurrencyEnum
    custom_fields: Optional[Dict[str, Any]]
    description: Optional[StrictStr]
    description_detailed: Optional[StrictStr]
    id: StrictStr
    is_deleted: Optional[StrictBool] = Field(default=False, description="If true, indicates that this object has been deleted")
    object: Optional[ObjectName] = None
    price_id: StrictStr
    product_id: StrictStr
    quantity: StrictInt
    updated_at: datetime = Field(description="DateTime at which the object was updated, in 'ISO 8601' format.")
    __properties: ClassVar[List[str]] = ["amount_subtotal_atom", "amount_total_atom", "billing_interval", "billing_interval_count", "checkout_session_id", "created_at", "currency", "custom_fields", "description", "description_detailed", "id", "is_deleted", "object", "price_id", "product_id", "quantity", "updated_at"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CheckoutSessionLineItemExternal from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if billing_interval (nullable) is None
        # and model_fields_set contains the field
        if self.billing_interval is None and "billing_interval" in self.model_fields_set:
            _dict['billing_interval'] = None

        # set to None if billing_interval_count (nullable) is None
        # and model_fields_set contains the field
        if self.billing_interval_count is None and "billing_interval_count" in self.model_fields_set:
            _dict['billing_interval_count'] = None

        # set to None if checkout_session_id (nullable) is None
        # and model_fields_set contains the field
        if self.checkout_session_id is None and "checkout_session_id" in self.model_fields_set:
            _dict['checkout_session_id'] = None

        # set to None if custom_fields (nullable) is None
        # and model_fields_set contains the field
        if self.custom_fields is None and "custom_fields" in self.model_fields_set:
            _dict['custom_fields'] = None

        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict['description'] = None

        # set to None if description_detailed (nullable) is None
        # and model_fields_set contains the field
        if self.description_detailed is None and "description_detailed" in self.model_fields_set:
            _dict['description_detailed'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CheckoutSessionLineItemExternal from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "amount_subtotal_atom": obj.get("amount_subtotal_atom"),
            "amount_total_atom": obj.get("amount_total_atom"),
            "billing_interval": obj.get("billing_interval"),
            "billing_interval_count": obj.get("billing_interval_count"),
            "checkout_session_id": obj.get("checkout_session_id"),
            "created_at": obj.get("created_at"),
            "currency": obj.get("currency"),
            "custom_fields": obj.get("custom_fields"),
            "description": obj.get("description"),
            "description_detailed": obj.get("description_detailed"),
            "id": obj.get("id"),
            "is_deleted": obj.get("is_deleted") if obj.get("is_deleted") is not None else False,
            "object": obj.get("object"),
            "price_id": obj.get("price_id"),
            "product_id": obj.get("product_id"),
            "quantity": obj.get("quantity"),
            "updated_at": obj.get("updated_at")
        })
        return _obj


