# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from getopenpay.models.coupon_duration import CouponDuration
from getopenpay.models.currency_enum import CurrencyEnum
from getopenpay.models.date_time_filter import DateTimeFilter
from getopenpay.models.int_range_filter import IntRangeFilter
from getopenpay.models.search_filter import SearchFilter
from typing import Optional, Set
from typing_extensions import Self

class CouponQueryParams(BaseModel):
    """
    CouponQueryParams
    """ # noqa: E501
    created_at: Optional[DateTimeFilter] = None
    currency: Optional[CurrencyEnum] = None
    duration: Optional[CouponDuration] = None
    expand: Optional[List[StrictStr]] = Field(default=None, description="Specifies which fields in the response should be expanded.")
    is_active: Optional[StrictBool] = None
    max_redemptions: Optional[IntRangeFilter] = None
    page_number: Optional[Annotated[int, Field(strict=True, ge=1)]] = Field(default=1, description="Page number")
    page_size: Optional[Annotated[int, Field(le=100, strict=True, ge=1)]] = Field(default=100, description="Page size")
    redeem_by: Optional[DateTimeFilter] = None
    search: Optional[SearchFilter] = None
    sort_descending: Optional[StrictBool] = Field(default=False, description="Sort direction.")
    sort_key: Optional[StrictStr] = Field(default='created_at', description="Key name based on which data is sorted.")
    updated_at: Optional[DateTimeFilter] = None
    __properties: ClassVar[List[str]] = ["created_at", "currency", "duration", "expand", "is_active", "max_redemptions", "page_number", "page_size", "redeem_by", "search", "sort_descending", "sort_key", "updated_at"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CouponQueryParams from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of created_at
        if self.created_at:
            _dict['created_at'] = self.created_at.to_dict()
        # override the default output from pydantic by calling `to_dict()` of max_redemptions
        if self.max_redemptions:
            _dict['max_redemptions'] = self.max_redemptions.to_dict()
        # override the default output from pydantic by calling `to_dict()` of redeem_by
        if self.redeem_by:
            _dict['redeem_by'] = self.redeem_by.to_dict()
        # override the default output from pydantic by calling `to_dict()` of search
        if self.search:
            _dict['search'] = self.search.to_dict()
        # override the default output from pydantic by calling `to_dict()` of updated_at
        if self.updated_at:
            _dict['updated_at'] = self.updated_at.to_dict()
        # set to None if created_at (nullable) is None
        # and model_fields_set contains the field
        if self.created_at is None and "created_at" in self.model_fields_set:
            _dict['created_at'] = None

        # set to None if currency (nullable) is None
        # and model_fields_set contains the field
        if self.currency is None and "currency" in self.model_fields_set:
            _dict['currency'] = None

        # set to None if duration (nullable) is None
        # and model_fields_set contains the field
        if self.duration is None and "duration" in self.model_fields_set:
            _dict['duration'] = None

        # set to None if is_active (nullable) is None
        # and model_fields_set contains the field
        if self.is_active is None and "is_active" in self.model_fields_set:
            _dict['is_active'] = None

        # set to None if max_redemptions (nullable) is None
        # and model_fields_set contains the field
        if self.max_redemptions is None and "max_redemptions" in self.model_fields_set:
            _dict['max_redemptions'] = None

        # set to None if redeem_by (nullable) is None
        # and model_fields_set contains the field
        if self.redeem_by is None and "redeem_by" in self.model_fields_set:
            _dict['redeem_by'] = None

        # set to None if search (nullable) is None
        # and model_fields_set contains the field
        if self.search is None and "search" in self.model_fields_set:
            _dict['search'] = None

        # set to None if updated_at (nullable) is None
        # and model_fields_set contains the field
        if self.updated_at is None and "updated_at" in self.model_fields_set:
            _dict['updated_at'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CouponQueryParams from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "created_at": DateTimeFilter.from_dict(obj["created_at"]) if obj.get("created_at") is not None else None,
            "currency": obj.get("currency"),
            "duration": obj.get("duration"),
            "expand": obj.get("expand"),
            "is_active": obj.get("is_active"),
            "max_redemptions": IntRangeFilter.from_dict(obj["max_redemptions"]) if obj.get("max_redemptions") is not None else None,
            "page_number": obj.get("page_number") if obj.get("page_number") is not None else 1,
            "page_size": obj.get("page_size") if obj.get("page_size") is not None else 100,
            "redeem_by": DateTimeFilter.from_dict(obj["redeem_by"]) if obj.get("redeem_by") is not None else None,
            "search": SearchFilter.from_dict(obj["search"]) if obj.get("search") is not None else None,
            "sort_descending": obj.get("sort_descending") if obj.get("sort_descending") is not None else False,
            "sort_key": obj.get("sort_key") if obj.get("sort_key") is not None else 'created_at',
            "updated_at": DateTimeFilter.from_dict(obj["updated_at"]) if obj.get("updated_at") is not None else None
        })
        return _obj


