# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from getopenpay.models.coupon_duration import CouponDuration
from getopenpay.models.currency_enum import CurrencyEnum
from typing import Optional, Set
from typing_extensions import Self

class CreateCouponRequest(BaseModel):
    """
    CreateCouponRequest
    """ # noqa: E501
    amount_atom_off: Optional[Annotated[int, Field(strict=True, ge=0)]] = None
    currency: Optional[CurrencyEnum] = None
    duration: Optional[CouponDuration] = Field(default=None, description="Specifies how long the discount will be in effect if used on a subscription. Defaults to once.")
    duration_in_months: Optional[StrictInt] = None
    is_active: Optional[StrictBool] = Field(default=True, description="Whether the coupon is available to be redeemed.")
    max_redemptions: Optional[StrictInt] = None
    name: StrictStr = Field(description="Name of the coupon displayed to customers on, for instance invoices, or receipts.")
    percent_off: Optional[Annotated[int, Field(le=100, strict=True)]] = None
    product_family_ids: Optional[List[StrictStr]] = Field(default=None, description="An array of Product Family IDs that this Coupon can apply to.")
    product_ids: Optional[List[StrictStr]] = Field(default=None, description="An array of Product IDs that this Coupon can apply to.")
    redeem_by: Optional[datetime] = None
    trial_days_off: Optional[Annotated[int, Field(strict=True, ge=0)]] = None
    __properties: ClassVar[List[str]] = ["amount_atom_off", "currency", "duration", "duration_in_months", "is_active", "max_redemptions", "name", "percent_off", "product_family_ids", "product_ids", "redeem_by", "trial_days_off"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateCouponRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if amount_atom_off (nullable) is None
        # and model_fields_set contains the field
        if self.amount_atom_off is None and "amount_atom_off" in self.model_fields_set:
            _dict['amount_atom_off'] = None

        # set to None if currency (nullable) is None
        # and model_fields_set contains the field
        if self.currency is None and "currency" in self.model_fields_set:
            _dict['currency'] = None

        # set to None if duration_in_months (nullable) is None
        # and model_fields_set contains the field
        if self.duration_in_months is None and "duration_in_months" in self.model_fields_set:
            _dict['duration_in_months'] = None

        # set to None if max_redemptions (nullable) is None
        # and model_fields_set contains the field
        if self.max_redemptions is None and "max_redemptions" in self.model_fields_set:
            _dict['max_redemptions'] = None

        # set to None if percent_off (nullable) is None
        # and model_fields_set contains the field
        if self.percent_off is None and "percent_off" in self.model_fields_set:
            _dict['percent_off'] = None

        # set to None if redeem_by (nullable) is None
        # and model_fields_set contains the field
        if self.redeem_by is None and "redeem_by" in self.model_fields_set:
            _dict['redeem_by'] = None

        # set to None if trial_days_off (nullable) is None
        # and model_fields_set contains the field
        if self.trial_days_off is None and "trial_days_off" in self.model_fields_set:
            _dict['trial_days_off'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateCouponRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "amount_atom_off": obj.get("amount_atom_off"),
            "currency": obj.get("currency"),
            "duration": obj.get("duration"),
            "duration_in_months": obj.get("duration_in_months"),
            "is_active": obj.get("is_active") if obj.get("is_active") is not None else True,
            "max_redemptions": obj.get("max_redemptions"),
            "name": obj.get("name"),
            "percent_off": obj.get("percent_off"),
            "product_family_ids": obj.get("product_family_ids"),
            "product_ids": obj.get("product_ids"),
            "redeem_by": obj.get("redeem_by"),
            "trial_days_off": obj.get("trial_days_off")
        })
        return _obj


