# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from getopenpay.models.collection_method_enum import CollectionMethodEnum
from getopenpay.models.invoice_item_details import InvoiceItemDetails
from getopenpay.models.invoice_type import InvoiceType
from getopenpay.models.selected_price_quantity import SelectedPriceQuantity
from typing import Optional, Set
from typing_extensions import Self

class CreateInvoiceRequest(BaseModel):
    """
    CreateInvoiceRequest
    """ # noqa: E501
    collection_method: Optional[CollectionMethodEnum] = None
    coupon_id: Optional[StrictStr] = None
    custom_fields: Optional[Dict[str, Any]] = None
    customer_id: StrictStr = Field(description="The external id of the customer.")
    description: Optional[StrictStr] = Field(default='Manual creation of invoice', description="Description for newly created invoice")
    email_invoice_on_finalization: Optional[StrictBool] = None
    finalize_invoice_immediately: Optional[StrictBool] = None
    invoice_item_details: Optional[Dict[str, InvoiceItemDetails]] = None
    invoice_type: Optional[InvoiceType] = Field(default=None, description="The type of invoice to create. Choose standard to create the subscription based invoice and one_off to create the one-off invoices.")
    is_preview: Optional[StrictBool] = Field(default=False, description="Whether the request is in preview mode (Invoice won't actually be created)")
    net_d: Optional[StrictInt] = None
    payment_method_id: Optional[StrictStr] = None
    selected_product_price_quantity: Optional[List[SelectedPriceQuantity]] = Field(default=None, description="This object contains details of selected product' price and quantity.")
    subscription_id: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["collection_method", "coupon_id", "custom_fields", "customer_id", "description", "email_invoice_on_finalization", "finalize_invoice_immediately", "invoice_item_details", "invoice_type", "is_preview", "net_d", "payment_method_id", "selected_product_price_quantity", "subscription_id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateInvoiceRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in invoice_item_details (dict)
        _field_dict = {}
        if self.invoice_item_details:
            for _key_invoice_item_details in self.invoice_item_details:
                if self.invoice_item_details[_key_invoice_item_details]:
                    _field_dict[_key_invoice_item_details] = self.invoice_item_details[_key_invoice_item_details].to_dict()
            _dict['invoice_item_details'] = _field_dict
        # override the default output from pydantic by calling `to_dict()` of each item in selected_product_price_quantity (list)
        _items = []
        if self.selected_product_price_quantity:
            for _item_selected_product_price_quantity in self.selected_product_price_quantity:
                if _item_selected_product_price_quantity:
                    _items.append(_item_selected_product_price_quantity.to_dict())
            _dict['selected_product_price_quantity'] = _items
        # set to None if collection_method (nullable) is None
        # and model_fields_set contains the field
        if self.collection_method is None and "collection_method" in self.model_fields_set:
            _dict['collection_method'] = None

        # set to None if coupon_id (nullable) is None
        # and model_fields_set contains the field
        if self.coupon_id is None and "coupon_id" in self.model_fields_set:
            _dict['coupon_id'] = None

        # set to None if custom_fields (nullable) is None
        # and model_fields_set contains the field
        if self.custom_fields is None and "custom_fields" in self.model_fields_set:
            _dict['custom_fields'] = None

        # set to None if email_invoice_on_finalization (nullable) is None
        # and model_fields_set contains the field
        if self.email_invoice_on_finalization is None and "email_invoice_on_finalization" in self.model_fields_set:
            _dict['email_invoice_on_finalization'] = None

        # set to None if finalize_invoice_immediately (nullable) is None
        # and model_fields_set contains the field
        if self.finalize_invoice_immediately is None and "finalize_invoice_immediately" in self.model_fields_set:
            _dict['finalize_invoice_immediately'] = None

        # set to None if invoice_item_details (nullable) is None
        # and model_fields_set contains the field
        if self.invoice_item_details is None and "invoice_item_details" in self.model_fields_set:
            _dict['invoice_item_details'] = None

        # set to None if net_d (nullable) is None
        # and model_fields_set contains the field
        if self.net_d is None and "net_d" in self.model_fields_set:
            _dict['net_d'] = None

        # set to None if payment_method_id (nullable) is None
        # and model_fields_set contains the field
        if self.payment_method_id is None and "payment_method_id" in self.model_fields_set:
            _dict['payment_method_id'] = None

        # set to None if subscription_id (nullable) is None
        # and model_fields_set contains the field
        if self.subscription_id is None and "subscription_id" in self.model_fields_set:
            _dict['subscription_id'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateInvoiceRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "collection_method": obj.get("collection_method"),
            "coupon_id": obj.get("coupon_id"),
            "custom_fields": obj.get("custom_fields"),
            "customer_id": obj.get("customer_id"),
            "description": obj.get("description") if obj.get("description") is not None else 'Manual creation of invoice',
            "email_invoice_on_finalization": obj.get("email_invoice_on_finalization"),
            "finalize_invoice_immediately": obj.get("finalize_invoice_immediately"),
            "invoice_item_details": dict(
                (_k, InvoiceItemDetails.from_dict(_v))
                for _k, _v in obj["invoice_item_details"].items()
            )
            if obj.get("invoice_item_details") is not None
            else None,
            "invoice_type": obj.get("invoice_type"),
            "is_preview": obj.get("is_preview") if obj.get("is_preview") is not None else False,
            "net_d": obj.get("net_d"),
            "payment_method_id": obj.get("payment_method_id"),
            "selected_product_price_quantity": [SelectedPriceQuantity.from_dict(_item) for _item in obj["selected_product_price_quantity"]] if obj.get("selected_product_price_quantity") is not None else None,
            "subscription_id": obj.get("subscription_id")
        })
        return _obj


