# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from getopenpay.models.credit_note_item_external import CreditNoteItemExternal
from getopenpay.models.credit_note_reason import CreditNoteReason
from getopenpay.models.currency_enum import CurrencyEnum
from getopenpay.models.object_name import ObjectName
from typing import Optional, Set
from typing_extensions import Self

class CreditNoteExternal(BaseModel):
    """
    CreditNoteExternal
    """ # noqa: E501
    created_at: datetime = Field(description="DateTime at which the object was created, in 'ISO 8601' format.")
    credit_amount_atom: StrictInt = Field(description="The integer amount representing the amount to credit the customer’s balance, which will be automatically applied to their next invoice. It is in atomic units (in USD this is cents).")
    currency: CurrencyEnum = Field(description="Three-letter ISO currency code, in lowercase.")
    id: StrictStr = Field(description="Unique Identifier of the credit_note.")
    invoice_id: StrictStr = Field(description="Unique ID of the invoice.")
    is_deleted: Optional[StrictBool] = Field(default=False, description="If true, indicates that this object has been deleted")
    items: List[CreditNoteItemExternal] = Field(description="List of credit_note_items.")
    object: Optional[ObjectName] = None
    reason: Optional[CreditNoteReason]
    refund_amount_atom: StrictInt = Field(description="The integer amount representing the amount to refund. If set, a refund will be created for the charge associated with the invoice. It is in atomic units (in USD this is cents).")
    total_amount_atom: StrictInt = Field(description="The integer amount representing the total amount of the credit note. It is in atomic units (in USD this is cents).")
    updated_at: datetime = Field(description="DateTime at which the object was updated, in 'ISO 8601' format.")
    __properties: ClassVar[List[str]] = ["created_at", "credit_amount_atom", "currency", "id", "invoice_id", "is_deleted", "items", "object", "reason", "refund_amount_atom", "total_amount_atom", "updated_at"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreditNoteExternal from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in items (list)
        _items = []
        if self.items:
            for _item_items in self.items:
                if _item_items:
                    _items.append(_item_items.to_dict())
            _dict['items'] = _items
        # set to None if reason (nullable) is None
        # and model_fields_set contains the field
        if self.reason is None and "reason" in self.model_fields_set:
            _dict['reason'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreditNoteExternal from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "created_at": obj.get("created_at"),
            "credit_amount_atom": obj.get("credit_amount_atom"),
            "currency": obj.get("currency"),
            "id": obj.get("id"),
            "invoice_id": obj.get("invoice_id"),
            "is_deleted": obj.get("is_deleted") if obj.get("is_deleted") is not None else False,
            "items": [CreditNoteItemExternal.from_dict(_item) for _item in obj["items"]] if obj.get("items") is not None else None,
            "object": obj.get("object"),
            "reason": obj.get("reason"),
            "refund_amount_atom": obj.get("refund_amount_atom"),
            "total_amount_atom": obj.get("total_amount_atom"),
            "updated_at": obj.get("updated_at")
        })
        return _obj


