# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from getopenpay.models.object_name import ObjectName
from typing import Optional, Set
from typing_extensions import Self

class DisputeExternal(BaseModel):
    """
    DisputeExternal
    """ # noqa: E501
    account_id: StrictStr = Field(description="Unique identifier for the account.")
    created_at: datetime = Field(description="DateTime at which the object was created, in 'ISO 8601' format.")
    id: StrictStr = Field(description="Unique identifier of the dispute.")
    is_deleted: Optional[StrictBool] = Field(default=False, description="If true, indicates that this object has been deleted")
    metadata: Optional[Dict[str, Any]] = None
    object: Optional[ObjectName] = None
    payment_intent_id: StrictStr = Field(description="The payment intent id.")
    reason: Optional[StrictStr] = None
    their_dispute_id: StrictStr = Field(description="There dispute id.")
    their_payment_intent_id: StrictStr = Field(description="Their payment intent id")
    updated_at: datetime = Field(description="DateTime at which the object was updated, in 'ISO 8601' format.")
    __properties: ClassVar[List[str]] = ["account_id", "created_at", "id", "is_deleted", "metadata", "object", "payment_intent_id", "reason", "their_dispute_id", "their_payment_intent_id", "updated_at"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DisputeExternal from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if metadata (nullable) is None
        # and model_fields_set contains the field
        if self.metadata is None and "metadata" in self.model_fields_set:
            _dict['metadata'] = None

        # set to None if reason (nullable) is None
        # and model_fields_set contains the field
        if self.reason is None and "reason" in self.model_fields_set:
            _dict['reason'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DisputeExternal from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "account_id": obj.get("account_id"),
            "created_at": obj.get("created_at"),
            "id": obj.get("id"),
            "is_deleted": obj.get("is_deleted") if obj.get("is_deleted") is not None else False,
            "metadata": obj.get("metadata"),
            "object": obj.get("object"),
            "payment_intent_id": obj.get("payment_intent_id"),
            "reason": obj.get("reason"),
            "their_dispute_id": obj.get("their_dispute_id"),
            "their_payment_intent_id": obj.get("their_payment_intent_id"),
            "updated_at": obj.get("updated_at")
        })
        return _obj


