# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from getopenpay.models.currency_enum import CurrencyEnum
from getopenpay.models.invoice_item_discount_amounts_external import InvoiceItemDiscountAmountsExternal
from getopenpay.models.object_name import ObjectName
from getopenpay.models.price_type_enum import PriceTypeEnum
from typing import Optional, Set
from typing_extensions import Self

class InvoiceItemExternal(BaseModel):
    """
    InvoiceItemExternal
    """ # noqa: E501
    account_id: StrictStr = Field(description="Unique identifier of the account.")
    amount_atom: StrictInt = Field(description="Total amount of invoice_item in atomic units (in USD this is cents).")
    amount_atom_considering_discount_applied: StrictInt = Field(description="Total amount of invoice_item in atomic units considering discounts. Contains both invoice-level and invoice item-level discounts")
    created_at: datetime = Field(description="DateTime at which the object was created, in 'ISO 8601' format.")
    currency: CurrencyEnum = Field(description="Three-letter ISO currency code, in lowercase.")
    customer_id: StrictStr = Field(description="Unique identifier of the customer.")
    description: Optional[StrictStr]
    discount_amount_atoms: List[InvoiceItemDiscountAmountsExternal] = Field(description="The amount_atom of all discount.")
    discounts: List[StrictStr] = Field(description="The discounts only directly applied to the InvoiceItem.")
    id: StrictStr = Field(description="Unique identifier of the invoice_item.")
    invoice_id: Optional[StrictStr]
    is_deleted: Optional[StrictBool] = Field(default=False, description="If true, indicates that this object has been deleted")
    name: StrictStr = Field(description="Name of the invoice_item.")
    object: Optional[ObjectName] = None
    period_end: datetime = Field(description="End of the usage period of the invoice_item. It is in 'ISO 8601' format.")
    period_start: datetime = Field(description="Start of the usage period of the invoice_item. It is in 'ISO 8601' format.")
    price_id: StrictStr = Field(description="Unique identifier of the price.")
    price_type: PriceTypeEnum = Field(description="Type of the price.")
    product_id: StrictStr = Field(description="Unique identifier of the product.")
    proration: StrictBool = Field(description="Whether the invoice item was created automatically as a proration adjustment when the customer switched plans.")
    proration_details_debit_invoice_item: Optional[StrictStr]
    quantity: StrictInt = Field(description="Quantity of the invoice_item.")
    subscription_cancelled_at: Optional[datetime] = None
    subscription_id: Optional[StrictStr]
    subscription_item_description: Optional[StrictStr] = None
    subscription_item_id: Optional[StrictStr] = None
    updated_at: datetime = Field(description="DateTime at which the object was updated, in 'ISO 8601' format.")
    __properties: ClassVar[List[str]] = ["account_id", "amount_atom", "amount_atom_considering_discount_applied", "created_at", "currency", "customer_id", "description", "discount_amount_atoms", "discounts", "id", "invoice_id", "is_deleted", "name", "object", "period_end", "period_start", "price_id", "price_type", "product_id", "proration", "proration_details_debit_invoice_item", "quantity", "subscription_cancelled_at", "subscription_id", "subscription_item_description", "subscription_item_id", "updated_at"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of InvoiceItemExternal from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in discount_amount_atoms (list)
        _items = []
        if self.discount_amount_atoms:
            for _item_discount_amount_atoms in self.discount_amount_atoms:
                if _item_discount_amount_atoms:
                    _items.append(_item_discount_amount_atoms.to_dict())
            _dict['discount_amount_atoms'] = _items
        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict['description'] = None

        # set to None if invoice_id (nullable) is None
        # and model_fields_set contains the field
        if self.invoice_id is None and "invoice_id" in self.model_fields_set:
            _dict['invoice_id'] = None

        # set to None if proration_details_debit_invoice_item (nullable) is None
        # and model_fields_set contains the field
        if self.proration_details_debit_invoice_item is None and "proration_details_debit_invoice_item" in self.model_fields_set:
            _dict['proration_details_debit_invoice_item'] = None

        # set to None if subscription_cancelled_at (nullable) is None
        # and model_fields_set contains the field
        if self.subscription_cancelled_at is None and "subscription_cancelled_at" in self.model_fields_set:
            _dict['subscription_cancelled_at'] = None

        # set to None if subscription_id (nullable) is None
        # and model_fields_set contains the field
        if self.subscription_id is None and "subscription_id" in self.model_fields_set:
            _dict['subscription_id'] = None

        # set to None if subscription_item_description (nullable) is None
        # and model_fields_set contains the field
        if self.subscription_item_description is None and "subscription_item_description" in self.model_fields_set:
            _dict['subscription_item_description'] = None

        # set to None if subscription_item_id (nullable) is None
        # and model_fields_set contains the field
        if self.subscription_item_id is None and "subscription_item_id" in self.model_fields_set:
            _dict['subscription_item_id'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of InvoiceItemExternal from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "account_id": obj.get("account_id"),
            "amount_atom": obj.get("amount_atom"),
            "amount_atom_considering_discount_applied": obj.get("amount_atom_considering_discount_applied"),
            "created_at": obj.get("created_at"),
            "currency": obj.get("currency"),
            "customer_id": obj.get("customer_id"),
            "description": obj.get("description"),
            "discount_amount_atoms": [InvoiceItemDiscountAmountsExternal.from_dict(_item) for _item in obj["discount_amount_atoms"]] if obj.get("discount_amount_atoms") is not None else None,
            "discounts": obj.get("discounts"),
            "id": obj.get("id"),
            "invoice_id": obj.get("invoice_id"),
            "is_deleted": obj.get("is_deleted") if obj.get("is_deleted") is not None else False,
            "name": obj.get("name"),
            "object": obj.get("object"),
            "period_end": obj.get("period_end"),
            "period_start": obj.get("period_start"),
            "price_id": obj.get("price_id"),
            "price_type": obj.get("price_type"),
            "product_id": obj.get("product_id"),
            "proration": obj.get("proration"),
            "proration_details_debit_invoice_item": obj.get("proration_details_debit_invoice_item"),
            "quantity": obj.get("quantity"),
            "subscription_cancelled_at": obj.get("subscription_cancelled_at"),
            "subscription_id": obj.get("subscription_id"),
            "subscription_item_description": obj.get("subscription_item_description"),
            "subscription_item_id": obj.get("subscription_item_id"),
            "updated_at": obj.get("updated_at")
        })
        return _obj


