# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from getopenpay.models.non_pci_integration_configuration_inner import NonPciIntegrationConfigurationInner
from getopenpay.models.non_pci_integration_enum import NonPciIntegrationEnum
from typing import Optional, Set
from typing_extensions import Self

class NonPciIntegration(BaseModel):
    """
    NonPciIntegration
    """ # noqa: E501
    account_id: StrictStr = Field(description="The account ID")
    configuration: Optional[List[NonPciIntegrationConfigurationInner]] = Field(default=None, description="The configuration fields")
    integration_id: StrictStr = Field(description="The integration ID")
    integration_type: NonPciIntegrationEnum = Field(description="The integration type")
    __properties: ClassVar[List[str]] = ["account_id", "configuration", "integration_id", "integration_type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NonPciIntegration from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in configuration (list)
        _items = []
        if self.configuration:
            for _item_configuration in self.configuration:
                if _item_configuration:
                    _items.append(_item_configuration.to_dict())
            _dict['configuration'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NonPciIntegration from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "account_id": obj.get("account_id"),
            "configuration": [NonPciIntegrationConfigurationInner.from_dict(_item) for _item in obj["configuration"]] if obj.get("configuration") is not None else None,
            "integration_id": obj.get("integration_id"),
            "integration_type": obj.get("integration_type")
        })
        return _obj


