# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
import re  # noqa: F401
from pydantic import BaseModel, ValidationError, field_validator
from typing import Optional
from getopenpay.models.boolean_config_field import BooleanConfigField
from getopenpay.models.enum_config_field import EnumConfigField
from getopenpay.models.number_config_field import NumberConfigField
from getopenpay.models.string_config_field import StringConfigField
from typing import Union, Any, Set, TYPE_CHECKING, Optional, Dict
from typing_extensions import Self

NONPCIINTEGRATIONCONFIGURATIONINNER_ANY_OF_SCHEMAS = ["BooleanConfigField", "EnumConfigField", "NumberConfigField", "StringConfigField"]

class NonPciIntegrationConfigurationInner(BaseModel):
    """
    NonPciIntegrationConfigurationInner
    """

    # data type: StringConfigField
    anyof_schema_1_validator: Optional[StringConfigField] = None
    # data type: NumberConfigField
    anyof_schema_2_validator: Optional[NumberConfigField] = None
    # data type: BooleanConfigField
    anyof_schema_3_validator: Optional[BooleanConfigField] = None
    # data type: EnumConfigField
    anyof_schema_4_validator: Optional[EnumConfigField] = None
    if TYPE_CHECKING:
        actual_instance: Optional[Union[BooleanConfigField, EnumConfigField, NumberConfigField, StringConfigField]] = None
    else:
        actual_instance: Any = None
    any_of_schemas: Set[str] = { "BooleanConfigField", "EnumConfigField", "NumberConfigField", "StringConfigField" }

    model_config = {
        "validate_assignment": True,
        "protected_namespaces": (),
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_anyof(cls, v):
        NonPciIntegrationConfigurationInner.model_construct()
        error_messages = []
        # validate data type: StringConfigField
        if not isinstance(v, StringConfigField):
            error_messages.append(f"Error! Input type `{type(v)}` is not `StringConfigField`")
        else:
            return v

        # validate data type: NumberConfigField
        if not isinstance(v, NumberConfigField):
            error_messages.append(f"Error! Input type `{type(v)}` is not `NumberConfigField`")
        else:
            return v

        # validate data type: BooleanConfigField
        if not isinstance(v, BooleanConfigField):
            error_messages.append(f"Error! Input type `{type(v)}` is not `BooleanConfigField`")
        else:
            return v

        # validate data type: EnumConfigField
        if not isinstance(v, EnumConfigField):
            error_messages.append(f"Error! Input type `{type(v)}` is not `EnumConfigField`")
        else:
            return v

        if error_messages:
            # no match
            raise ValueError("No match found when setting the actual_instance in NonPciIntegrationConfigurationInner with anyOf schemas: BooleanConfigField, EnumConfigField, NumberConfigField, StringConfigField. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Dict[str, Any]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        # anyof_schema_1_validator: Optional[StringConfigField] = None
        try:
            instance.actual_instance = StringConfigField.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[NumberConfigField] = None
        try:
            instance.actual_instance = NumberConfigField.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_3_validator: Optional[BooleanConfigField] = None
        try:
            instance.actual_instance = BooleanConfigField.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_4_validator: Optional[EnumConfigField] = None
        try:
            instance.actual_instance = EnumConfigField.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError("No match found when deserializing the JSON string into NonPciIntegrationConfigurationInner with anyOf schemas: BooleanConfigField, EnumConfigField, NumberConfigField, StringConfigField. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], BooleanConfigField, EnumConfigField, NumberConfigField, StringConfigField]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


