# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from getopenpay.models.checkout_mode import CheckoutMode
from getopenpay.models.checkout_preferences_output import CheckoutPreferencesOutput
from getopenpay.models.object_name import ObjectName
from getopenpay.models.payment_link_line_item_external import PaymentLinkLineItemExternal
from typing import Optional, Set
from typing_extensions import Self

class PaymentLinkExternal(BaseModel):
    """
    PaymentLinkExternal
    """ # noqa: E501
    account_id: StrictStr = Field(description="Unique Identifier of the account.")
    account_name: StrictStr = Field(description="Name of the account.")
    active: StrictBool = Field(description="Whether a payment link is active or not.")
    checkout_preferences: Optional[CheckoutPreferencesOutput]
    coupon_id: Optional[StrictStr] = None
    created_at: datetime = Field(description="DateTime at which the object was created, in 'ISO 8601' format.")
    currency: Optional[StrictStr]
    custom_fields: Optional[Dict[str, Any]] = None
    customer_email: Optional[StrictStr]
    customer_id: Optional[StrictStr]
    id: StrictStr = Field(description="Unique Identifier of the checkout session.")
    is_deleted: Optional[StrictBool] = Field(default=False, description="If true, indicates that this object has been deleted")
    line_items: List[PaymentLinkLineItemExternal] = Field(description="The line items purchased by the customers.")
    mode: CheckoutMode = Field(description="The mode of the checkout sessions created by this payment link.")
    object: Optional[ObjectName] = None
    secure_token: StrictStr = Field(description="The random secure token associated with the payment link.")
    success_url: Optional[StrictStr]
    trial_end: Optional[datetime]
    trial_from_price: Optional[StrictBool]
    trial_period_days: Optional[StrictInt]
    updated_at: datetime = Field(description="DateTime at which the object was updated, in 'ISO 8601' format.")
    url: StrictStr = Field(description="The main URL for this payment link.")
    __properties: ClassVar[List[str]] = ["account_id", "account_name", "active", "checkout_preferences", "coupon_id", "created_at", "currency", "custom_fields", "customer_email", "customer_id", "id", "is_deleted", "line_items", "mode", "object", "secure_token", "success_url", "trial_end", "trial_from_price", "trial_period_days", "updated_at", "url"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PaymentLinkExternal from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of checkout_preferences
        if self.checkout_preferences:
            _dict['checkout_preferences'] = self.checkout_preferences.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in line_items (list)
        _items = []
        if self.line_items:
            for _item_line_items in self.line_items:
                if _item_line_items:
                    _items.append(_item_line_items.to_dict())
            _dict['line_items'] = _items
        # set to None if checkout_preferences (nullable) is None
        # and model_fields_set contains the field
        if self.checkout_preferences is None and "checkout_preferences" in self.model_fields_set:
            _dict['checkout_preferences'] = None

        # set to None if coupon_id (nullable) is None
        # and model_fields_set contains the field
        if self.coupon_id is None and "coupon_id" in self.model_fields_set:
            _dict['coupon_id'] = None

        # set to None if currency (nullable) is None
        # and model_fields_set contains the field
        if self.currency is None and "currency" in self.model_fields_set:
            _dict['currency'] = None

        # set to None if custom_fields (nullable) is None
        # and model_fields_set contains the field
        if self.custom_fields is None and "custom_fields" in self.model_fields_set:
            _dict['custom_fields'] = None

        # set to None if customer_email (nullable) is None
        # and model_fields_set contains the field
        if self.customer_email is None and "customer_email" in self.model_fields_set:
            _dict['customer_email'] = None

        # set to None if customer_id (nullable) is None
        # and model_fields_set contains the field
        if self.customer_id is None and "customer_id" in self.model_fields_set:
            _dict['customer_id'] = None

        # set to None if success_url (nullable) is None
        # and model_fields_set contains the field
        if self.success_url is None and "success_url" in self.model_fields_set:
            _dict['success_url'] = None

        # set to None if trial_end (nullable) is None
        # and model_fields_set contains the field
        if self.trial_end is None and "trial_end" in self.model_fields_set:
            _dict['trial_end'] = None

        # set to None if trial_from_price (nullable) is None
        # and model_fields_set contains the field
        if self.trial_from_price is None and "trial_from_price" in self.model_fields_set:
            _dict['trial_from_price'] = None

        # set to None if trial_period_days (nullable) is None
        # and model_fields_set contains the field
        if self.trial_period_days is None and "trial_period_days" in self.model_fields_set:
            _dict['trial_period_days'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PaymentLinkExternal from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "account_id": obj.get("account_id"),
            "account_name": obj.get("account_name"),
            "active": obj.get("active"),
            "checkout_preferences": CheckoutPreferencesOutput.from_dict(obj["checkout_preferences"]) if obj.get("checkout_preferences") is not None else None,
            "coupon_id": obj.get("coupon_id"),
            "created_at": obj.get("created_at"),
            "currency": obj.get("currency"),
            "custom_fields": obj.get("custom_fields"),
            "customer_email": obj.get("customer_email"),
            "customer_id": obj.get("customer_id"),
            "id": obj.get("id"),
            "is_deleted": obj.get("is_deleted") if obj.get("is_deleted") is not None else False,
            "line_items": [PaymentLinkLineItemExternal.from_dict(_item) for _item in obj["line_items"]] if obj.get("line_items") is not None else None,
            "mode": obj.get("mode"),
            "object": obj.get("object"),
            "secure_token": obj.get("secure_token"),
            "success_url": obj.get("success_url"),
            "trial_end": obj.get("trial_end"),
            "trial_from_price": obj.get("trial_from_price"),
            "trial_period_days": obj.get("trial_period_days"),
            "updated_at": obj.get("updated_at"),
            "url": obj.get("url")
        })
        return _obj


