# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from getopenpay.models.object_name import ObjectName
from typing import Optional, Set
from typing_extensions import Self

class PortalSessionExternal(BaseModel):
    """
    PortalSessionExternal
    """ # noqa: E501
    account_id: StrictStr = Field(description="Unique identifier for the account.")
    created_at: datetime = Field(description="DateTime at which the object was created, in 'ISO 8601' format.")
    customer_id: StrictStr = Field(description="The ID of an existing customer.")
    id: StrictStr = Field(description="The ID of the portal session.")
    is_deleted: Optional[StrictBool] = Field(default=False, description="If true, indicates that this object has been deleted")
    object: Optional[ObjectName] = None
    return_url: StrictStr = Field(description="The default URL to redirect customers to when they click on the portal\"s link to return to your website.")
    token: StrictStr = Field(description="The short-lived token of the session that gives customers access to the customer portal.")
    updated_at: datetime = Field(description="DateTime at which the object was updated, in 'ISO 8601' format.")
    url: StrictStr = Field(description="The short-lived URL of the session that gives customers access to the customer portal.")
    __properties: ClassVar[List[str]] = ["account_id", "created_at", "customer_id", "id", "is_deleted", "object", "return_url", "token", "updated_at", "url"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PortalSessionExternal from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PortalSessionExternal from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "account_id": obj.get("account_id"),
            "created_at": obj.get("created_at"),
            "customer_id": obj.get("customer_id"),
            "id": obj.get("id"),
            "is_deleted": obj.get("is_deleted") if obj.get("is_deleted") is not None else False,
            "object": obj.get("object"),
            "return_url": obj.get("return_url"),
            "token": obj.get("token"),
            "updated_at": obj.get("updated_at"),
            "url": obj.get("url")
        })
        return _obj


