# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from getopenpay.models.object_name import ObjectName
from typing import Optional, Set
from typing_extensions import Self

class ProductExternal(BaseModel):
    """
    ProductExternal
    """ # noqa: E501
    account_sku: Optional[StrictStr]
    created_at: datetime = Field(description="DateTime at which the object was created, in 'ISO 8601' format.")
    custom_fields: Optional[Dict[str, Any]] = None
    default_price: Optional[StrictStr]
    description: Optional[StrictStr]
    features: List[StrictStr] = Field(description="List of product features.")
    id: StrictStr = Field(description="Unique identifier of the product.")
    is_active: StrictBool = Field(description="Whether the product is currently available for purchase.")
    is_deleted: Optional[StrictBool] = Field(default=False, description="If true, indicates that this object has been deleted")
    metadata: Optional[Dict[str, Any]] = None
    name: StrictStr = Field(description="Name of product.")
    object: Optional[ObjectName] = None
    prices: List[PriceExternal]
    unit_label: Optional[StrictStr]
    updated_at: datetime = Field(description="DateTime at which the object was updated, in 'ISO 8601' format.")
    __properties: ClassVar[List[str]] = ["account_sku", "created_at", "custom_fields", "default_price", "description", "features", "id", "is_active", "is_deleted", "metadata", "name", "object", "prices", "unit_label", "updated_at"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ProductExternal from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in prices (list)
        _items = []
        if self.prices:
            for _item_prices in self.prices:
                if _item_prices:
                    _items.append(_item_prices.to_dict())
            _dict['prices'] = _items
        # set to None if account_sku (nullable) is None
        # and model_fields_set contains the field
        if self.account_sku is None and "account_sku" in self.model_fields_set:
            _dict['account_sku'] = None

        # set to None if custom_fields (nullable) is None
        # and model_fields_set contains the field
        if self.custom_fields is None and "custom_fields" in self.model_fields_set:
            _dict['custom_fields'] = None

        # set to None if default_price (nullable) is None
        # and model_fields_set contains the field
        if self.default_price is None and "default_price" in self.model_fields_set:
            _dict['default_price'] = None

        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict['description'] = None

        # set to None if metadata (nullable) is None
        # and model_fields_set contains the field
        if self.metadata is None and "metadata" in self.model_fields_set:
            _dict['metadata'] = None

        # set to None if unit_label (nullable) is None
        # and model_fields_set contains the field
        if self.unit_label is None and "unit_label" in self.model_fields_set:
            _dict['unit_label'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ProductExternal from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "account_sku": obj.get("account_sku"),
            "created_at": obj.get("created_at"),
            "custom_fields": obj.get("custom_fields"),
            "default_price": obj.get("default_price"),
            "description": obj.get("description"),
            "features": obj.get("features"),
            "id": obj.get("id"),
            "is_active": obj.get("is_active"),
            "is_deleted": obj.get("is_deleted") if obj.get("is_deleted") is not None else False,
            "metadata": obj.get("metadata"),
            "name": obj.get("name"),
            "object": obj.get("object"),
            "prices": [PriceExternal.from_dict(_item) for _item in obj["prices"]] if obj.get("prices") is not None else None,
            "unit_label": obj.get("unit_label"),
            "updated_at": obj.get("updated_at")
        })
        return _obj

from getopenpay.models.price_external import PriceExternal
# TODO: Rewrite to not use raise_errors
ProductExternal.model_rebuild(raise_errors=False)

