# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from getopenpay.models.invoice_external import InvoiceExternal
from getopenpay.models.subscription_external import SubscriptionExternal
from typing import Optional, Set
from typing_extensions import Self

class UpdateSubscriptionResponse(BaseModel):
    """
    UpdateSubscriptionResponse
    """ # noqa: E501
    invoices: List[InvoiceExternal] = Field(description="List of invoices created")
    renewal_invoices: Optional[List[InvoiceExternal]] = Field(default=None, description="List of renewal invoices created")
    subscriptions: List[SubscriptionExternal] = Field(description="List of subscriptions updated.")
    __properties: ClassVar[List[str]] = ["invoices", "renewal_invoices", "subscriptions"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateSubscriptionResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in invoices (list)
        _items = []
        if self.invoices:
            for _item_invoices in self.invoices:
                if _item_invoices:
                    _items.append(_item_invoices.to_dict())
            _dict['invoices'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in renewal_invoices (list)
        _items = []
        if self.renewal_invoices:
            for _item_renewal_invoices in self.renewal_invoices:
                if _item_renewal_invoices:
                    _items.append(_item_renewal_invoices.to_dict())
            _dict['renewal_invoices'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in subscriptions (list)
        _items = []
        if self.subscriptions:
            for _item_subscriptions in self.subscriptions:
                if _item_subscriptions:
                    _items.append(_item_subscriptions.to_dict())
            _dict['subscriptions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateSubscriptionResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "invoices": [InvoiceExternal.from_dict(_item) for _item in obj["invoices"]] if obj.get("invoices") is not None else None,
            "renewal_invoices": [InvoiceExternal.from_dict(_item) for _item in obj["renewal_invoices"]] if obj.get("renewal_invoices") is not None else None,
            "subscriptions": [SubscriptionExternal.from_dict(_item) for _item in obj["subscriptions"]] if obj.get("subscriptions") is not None else None
        })
        return _obj


