# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class WebhookDeliveryResult(BaseModel):
    """
    WebhookDeliveryResult
    """ # noqa: E501
    attempt_time: datetime = Field(description="Webhook delivery attempt time in 'ISO 8601' format.")
    event_id: StrictStr = Field(description="Unique id for the event which was sent to the webhook url.")
    response_code: StrictInt = Field(description="HTTP response code received upon attempted delivery to webhook endpoint")
    response_text: Optional[StrictStr] = None
    webhook_id: StrictStr = Field(description="Unique id for the webhook url to which the event was sent.")
    __properties: ClassVar[List[str]] = ["attempt_time", "event_id", "response_code", "response_text", "webhook_id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WebhookDeliveryResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if response_text (nullable) is None
        # and model_fields_set contains the field
        if self.response_text is None and "response_text" in self.model_fields_set:
            _dict['response_text'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WebhookDeliveryResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "attempt_time": obj.get("attempt_time"),
            "event_id": obj.get("event_id"),
            "response_code": obj.get("response_code"),
            "response_text": obj.get("response_text"),
            "webhook_id": obj.get("webhook_id")
        })
        return _obj


